// jQuery Context Menu Plugin

//

// Version 1.01

//

// Cory S.N. LaViska

// A Beautiful Site (http://abeautifulsite.net/)

//

// More info: http://abeautifulsite.net/2008/09/jquery-context-menu-plugin/

//

// Terms of Use

//

// This plugin is dual-licensed under the GNU General Public License

//   and the MIT License and is copyright A Beautiful Site, LLC.

//

( function($) {

	$.extend($.fn, {

		

		contextMenu: function(o, callback) {

			// Defaults

			if( o.menu == undefined ) return false;

			if( o.inSpeed == undefined ) o.inSpeed = 150;

			if( o.outSpeed == undefined ) o.outSpeed = 75;

			// 0 needs to be -1 for expected results (no fade)

			if( o.inSpeed == 0 ) o.inSpeed = -1;

			if( o.outSpeed == 0 ) o.outSpeed = -1;

			// Loop each context menu

			$(this).each( function() {

				var el = $(this);

				var offset = $(el).offset();

				// Add contextMenu class

				$('#' + o.menu).addClass('contextMenu');

				// Simulate a true right click

				$(this).mousedown( function(e) {

					var evt = e;

					// move contextmenu elements to end of DOM so that they get positioned correctly

                    $(".contextMenu").addClass('crm-contextmenu').remove().appendTo('body');



                    evt.stopPropagation();

					$(this).mouseup( function(e) {

						e.stopPropagation();

						var srcElement = $(this);

						$(this).unbind('mouseup');

						if( evt.button == 2 ) {

							// Hide context menus that may be showing

							$(".contextMenu").hide();

							// Get this context menu

							var menu = $('#' + o.menu);

							

							if( $(el).hasClass('disabled') ) return false;

							

							// Detect mouse position

							var d = {}, x, y;

							if( self.innerHeight ) {

								d.pageYOffset = self.pageYOffset;

								d.pageXOffset = self.pageXOffset;

								d.innerHeight = self.innerHeight;

								d.innerWidth = self.innerWidth;

							} else if( document.documentElement &&

								document.documentElement.clientHeight ) {

								d.pageYOffset = document.documentElement.scrollTop;

								d.pageXOffset = document.documentElement.scrollLeft;

								d.innerHeight = document.documentElement.clientHeight;

								d.innerWidth = document.documentElement.clientWidth;

							} else if( document.body ) {

								d.pageYOffset = document.body.scrollTop;

								d.pageXOffset = document.body.scrollLeft;

								d.innerHeight = document.body.clientHeight;

								d.innerWidth = document.body.clientWidth;

							}

							(e.pageX) ? x = e.pageX : x = e.clientX + d.scrollLeft;

							(e.pageY) ? y = e.pageY : y = e.clientY + d.scrollTop;

							

							// Show the menu

							$(document).unbind('click');

							$(menu).css({ top: y, left: x }).fadeIn(o.inSpeed);

							// Hover events

							$(menu).find('A').mouseover( function() {

								$(menu).find('LI.hover').removeClass('hover');

								$(this).parent().addClass('hover');

							}).mouseout( function() {

								$(menu).find('LI.hover').removeClass('hover');

							});

							

							// Keyboard

							$(document).keypress( function(e) {

								switch( e.keyCode ) {

									case 38: // up

										if( $(menu).find('LI.hover').size() == 0 ) {

											$(menu).find('LI:last').addClass('hover');

										} else {

											$(menu).find('LI.hover').removeClass('hover').prevAll('LI:not(.disabled)').eq(0).addClass('hover');

											if( $(menu).find('LI.hover').size() == 0 ) $(menu).find('LI:last').addClass('hover');

										}

									break;

									case 40: // down

										if( $(menu).find('LI.hover').size() == 0 ) {

											$(menu).find('LI:first').addClass('hover');

										} else {

											$(menu).find('LI.hover').removeClass('hover').nextAll('LI:not(.disabled)').eq(0).addClass('hover');

											if( $(menu).find('LI.hover').size() == 0 ) $(menu).find('LI:first').addClass('hover');

										}

									break;

									case 13: // enter

										$(menu).find('LI.hover A').trigger('click');

									break;

									case 27: // esc

										$(document).trigger('click');

